<div fxLayout='row' fxLayout.xs="column" fxLayoutGap="1%" fxLayoutAlign="space-around" style="margin: 2%">
  <form [formGroup]="searchForm" (ngSubmit)="search()">
    <mat-form-field class="example-form-field">
      <mat-label>Dungeon suchen</mat-label>
      <input matInput id="searchDings" type="number" formControlName="dungeonId">
      <button mat-button matSuffix mat-icon-button aria-label="Clear" type="submit">
        <mat-icon>search</mat-icon>
      </button>
    </mat-form-field>
  </form>
  <button mat-raised-button color="primary" [matMenuTriggerFor]="menu">
    Neues Dungeon erstellen
    <mat-icon class="addRoomIcon">add</mat-icon>
  </button>
</div>

<mat-menu #menu="matMenu">
  <div style="padding: 10px" (click)="$event.stopPropagation()" (keydown)="$event.stopPropagation()" fxLayout="column"
       fxLayoutGap="5px">
    <form [formGroup]="dungeonForm" (ngSubmit)="createGame()">
      <div>
        <mat-form-field>
          <mat-label>Dungeonname</mat-label>
          <input id="dungeonNameInput" matInput type="email" formControlName="dungeonName">
          <mat-error *ngIf="dungeonForm.controls.dungeonName.invalid">Dungeonname erforderlich!</mat-error>
        </mat-form-field>
        <div>
          <mat-form-field>
            <mat-label>Max. Spieleranzahl</mat-label>
            <input id="spielerAnzahlInput" matInput type="number" min="0" formControlName="maxPlayers">
            <mat-error *ngIf="dungeonForm.controls.maxPlayers.invalid">Maximale Spieleranzahl erforderlich!</mat-error>
          </mat-form-field>
        </div>
        <div>
          <button mat-raised-button id="dungeonErstellenButton" color="primary" type="submit" [disabled]="dungeonForm.invalid">Dungeon erstellen
          </button>
        </div>
      </div>
    </form>
  </div>
</mat-menu>
<hr/>
<div fxLayout="row wrap">

  <div fxFlex="30%" style="margin-left: 5%">
    <h2 style="text-align: center">Eigene Dungeons</h2>
    <div *ngFor="let game of allUserGames">
      <mat-card style="margin: 1%">
        <mat-card-header>
          <mat-card-title>{{game.name}}</mat-card-title>
          <mat-card-subtitle>Dungeon ID:&nbsp;{{game.id}}</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.running == true">Aktiv</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.running == false && game.dungeonStatus == 'PUBLIC'">Inaktiv</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.running == false && game.dungeonStatus == 'WIP'">In Bearbeitung</mat-card-subtitle>

          <mat-card-subtitle *ngIf="game.builder==userID">Builder</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.dungeonMaster==userID">Dungeon Master</mat-card-subtitle>
        </mat-card-header>
        <mat-card-actions>
          <button mat-raised-button color="primary" (click)="alterGame(game)" [disabled]="game.dungeonStatus == 'PUBLIC'">
            Bearbeiten
            <mat-icon>edit</mat-icon>
          </button>
          <button mat-raised-button color="warn" (click)="rollBackDungeon(game.id)" [disabled]="game.dungeonStatus == 'WIP'">
            Reset
            <mat-icon>restart_alt</mat-icon>
          </button>
        </mat-card-actions>
      </mat-card>
    </div>
  </div>
  <div fxFlex="30%">
    <h2 style="text-align: center">Aktive Dungeons</h2>
    <div *ngFor="let game of allActiveGames">
      <mat-card style="margin: 1%">
        <mat-card-header>
          <mat-card-title>{{game.name}}</mat-card-title>
          <mat-card-subtitle>Aktiv</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.builder==userID">Builder</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.dungeonMaster==userID">Dungeon Master</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.password != null" >Privat</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.password == null" >Öffentlich</mat-card-subtitle>
        </mat-card-header>
        <mat-card-actions>
          <button *ngIf="game.dungeonMaster!=userID" mat-raised-button color="primary" (click)="getGamePasswordDialog(game)">Beitreten</button>
          <button *ngIf="game.dungeonMaster==userID" mat-raised-button color="primary" (click)="endGame(game)">Stopp</button>
        </mat-card-actions>
      </mat-card>
    </div>
  </div>
  <div fxFlex="30%">
    <h2 style="text-align: center">Inaktive Dungeons</h2>
    <div *ngFor="let game of allInactiveGames">
      <mat-card style="margin: 1%">
        <mat-card-header>
          <mat-card-title>{{game.name}}</mat-card-title>
          <mat-card-subtitle>Inaktiv</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.builder==userID">Builder</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.dungeonMaster==userID">Dungeon Master</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.password != null" >Privat</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.password == null" >Öffentlich</mat-card-subtitle>
        </mat-card-header>
        <mat-card-actions>
          <button mat-raised-button color="primary" (click)="getGamePasswordDialog(game)">Charakter</button>
          <button mat-raised-button color="primary" (click)="startDungeon(game.id)"
                  *ngIf="game.dungeonMaster == userID">Dungeonmaster
          </button>
          <button mat-raised-button color="primary" (click)="changePasswordDialog(game)"
                  *ngIf="game.dungeonMaster == userID">Passwort setzen
          </button>
        </mat-card-actions>
      </mat-card>
    </div>
  </div>
  <div fxFlex="100%">
    <h2 style="text-align: center">Alle Dungeons</h2>
    <div *ngFor="let game of allPublicGames">
      <mat-card style="margin: 1%; float: left; width: 30%; box-sizing: border-box">
        <mat-card-header>
          <mat-card-title>{{game.name}}</mat-card-title>
          <mat-card-subtitle *ngIf="game.builder==userID && game.dungeonMaster!=userID">Builder</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.builder!=userID && game.dungeonMaster==userID">Dungeon Master</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.builder!=userID && game.dungeonMaster!=userID && game.password != null" >Privat</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.builder!=userID && game.dungeonMaster!=userID && game.password == null" >Öffentlich</mat-card-subtitle>
          <mat-card-subtitle *ngIf="game.builder==userID && game.dungeonMaster==userID">Dungeon Master - Builder</mat-card-subtitle>
        </mat-card-header>
        <mat-card-actions>
          <button mat-raised-button color="primary" (click)="getGamePasswordDialog(game)">Charakter</button>
          <button mat-raised-button color="primary" (click)="startDungeon(game.id)"
                  *ngIf="game.dungeonMaster == userID">Dungeonmaster
          </button>
        </mat-card-actions>
      </mat-card>
    </div>
  </div>
</div>


